com.io7m.r2.core

## Class R2MaskBuffer

- java.lang.Object
- - com.io7m.r2.core.R2MaskBuffer

- All Implemented Interfaces:
    com.io7m.jcanephora.core.JCGLResourceSizedType, com.io7m.jcanephora.core.JCGLResourceUsableType, R2DeletableType, R2MaskBufferType, R2MaskBufferUsableType, R2RenderTargetType<R2MaskBufferDescriptionType>, R2RenderTargetUsableType<R2MaskBufferDescriptionType>

      public final class R2MaskBuffer
      extends Object
      implements R2MaskBufferType

  Default implementation of the `R2MaskBufferType` interface.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.io7m.jareas.core.AreaInclusiveUnsignedLType` | `area()`
    `void` | `clearBoundPrimaryFramebuffer(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)` Clear the primary framebuffer to render target specific default values, changing any current render state necessary to achieve this.
    `void` | `delete(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)` Delete the current object.
    `R2MaskBufferDescriptionType` | `description()`
    `com.io7m.junsigned.ranges.UnsignedRangeInclusiveL` | `getRange()`
    `boolean` | `isDeleted()`
    `R2Texture2DUsableType` | `maskTexture()`
    `static R2MaskBufferType` | `newMaskBuffer(com.io7m.jcanephora.core.api.JCGLFramebuffersType g_fb, com.io7m.jcanephora.core.api.JCGLTexturesType g_t, com.io7m.jcanephora.texture_unit_allocator.JCGLTextureUnitContextParentType tc, R2MaskBufferDescriptionType desc)` Construct a new mask buffer.
    `com.io7m.jcanephora.core.JCGLFramebufferUsableType` | `primaryFramebuffer()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### newMaskBuffer

          public static R2MaskBufferType newMaskBuffer(com.io7m.jcanephora.core.api.JCGLFramebuffersType g_fb,
                                                       com.io7m.jcanephora.core.api.JCGLTexturesType g_t,
                                                       com.io7m.jcanephora.texture_unit_allocator.JCGLTextureUnitContextParentType tc,
                                                       R2MaskBufferDescriptionType desc)

      Construct a new mask buffer.
      Parameters:
        `g_fb` - A framebuffer interface
        `g_t` - A texture interface
        `tc` - A texture unit context
        `desc` - The mask buffer description
      Returns:
        A new mask buffer

    - #### maskTexture

          public R2Texture2DUsableType maskTexture()

      Specified by:
        `maskTexture` in interface `R2MaskBufferUsableType`
      Returns:
        The mask texture

    - #### primaryFramebuffer

          public com.io7m.jcanephora.core.JCGLFramebufferUsableType primaryFramebuffer()

      Specified by:
        `primaryFramebuffer` in interface `R2RenderTargetUsableType<R2MaskBufferDescriptionType>`
      Returns:
        The framebuffer

    - #### area

          public com.io7m.jareas.core.AreaInclusiveUnsignedLType area()

      Specified by:
        `area` in interface `R2RenderTargetUsableType<R2MaskBufferDescriptionType>`
      Returns:
        The viewport area

    - #### description

          public R2MaskBufferDescriptionType description()

      Specified by:
        `description` in interface `R2RenderTargetUsableType<R2MaskBufferDescriptionType>`
      Returns:
        The description used to create the render target

    - #### getRange

          public com.io7m.junsigned.ranges.UnsignedRangeInclusiveL getRange()

      Specified by:
        `getRange` in interface `com.io7m.jcanephora.core.JCGLResourceSizedType`

    - #### isDeleted

          public boolean isDeleted()

      Specified by:
        `isDeleted` in interface `com.io7m.jcanephora.core.JCGLResourceUsableType`

    - #### delete

          public void delete(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)
                      throws R2Exception

      Description copied from interface: `R2DeletableType`
      Delete the current object.
      Specified by:
        `delete` in interface `R2DeletableType`
      Parameters:
        `g` - An OpenGL interface
      Throws:
        `R2Exception` - On errors

    - #### clearBoundPrimaryFramebuffer

          public void clearBoundPrimaryFramebuffer(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)
                                            throws R2RendererExceptionFramebufferNotBound

      Description copied from interface: `R2RenderTargetUsableType`
      Clear the primary framebuffer to render target specific default values, changing any current render state necessary to achieve this.
      Specified by:
        `clearBoundPrimaryFramebuffer` in interface `R2RenderTargetUsableType<R2MaskBufferDescriptionType>`
      Parameters:
        `g` - A GL interface
      Throws:
        `R2RendererExceptionFramebufferNotBound` - If the framebuffer is not bound

Copyright © 2016 <code@io7m.com> http://io7m.com